;v 1.00/13.05.2016
;**************************************
;*        fuse-        *
;*    ATtiny2313. *
;*    : ATtiny2313.    *
;*   : ., 1,00 MHz.  *
;*         :  ..          *      
;**************************************
;  , 2016.    !
;    Atmel AVR Studio (v 4.12).


;============ ===========

.device ATtiny2313
.include "tn2313def.inc"
.list

/*:    fuse-.
 ,  ""  ""   
 "", ,  ""
( ,   fuse-)  
   ( - .  1
    ).*/
.equ ChipErase = 0b00000001
.equ WriteFuse = 0b00000010
.equ ReadFuse  = 0b00100000

.equ LowFuse = 0b00100110
.equ HghFuse = 0b11111011
.equ SecFuse = 0b11111111

;  -   .
.def Temp = R16
.def Data = R17    ; Data(R17)      .
.def Del1 = R18
.def Del2 = R19

;  ""    
; "" -   .
.equ D7 = PORTD6 

.equ OE = PORTA0
.equ WR = PORTA1
.equ XT1 = PORTD4
.equ XA0 = PORTD0
.equ XA1 = PORTB7   ;  ATtiny2313   XA1 
.equ BS1 = PORTD1
.equ BS2 = PORTB7   ;  BS2 -       ( 11).
.equ RST = PORTD3

.equ LED = PORTD2   ; PORTD2 ""   .
.equ BSY = PIND5    ;  .  .0 - , .1 - .

.cseg
.org 0x00


;============ ============

;----- 

       ldi      Temp,    RAMEND
	   out      SPL,     Temp

;----- 

       ldi     Temp,     0b00000011
	   out     DDRA,     Temp
       ldi     Temp,     0xFF
	   out     DDRB,     Temp
	   out     DDRD,     Temp   
       cbi     DDRD,     BSY   ; BSY  ,   -  .


;===================================

;-----   
      
	   rcall   Delay1ms        ; -   ,  ""   . .
       sbi     PORTD,    RST
	   rcall   Tact
       
	   /*        
	        XTAL1   3-6 
	   ,     !
	   (. data-sheet,  ATtiny2313    ;)*/
       ;ldi     Temp,     6     ;  ,   XTAL1.
	   ;rcall   Tact
	   ;dec     Temp
	   ;brne    PC-2

	   cbi     PORTD,    RST
       rcall   Delay1ms

;-----  ""
 
       ;.  2     .
       sbis    PIND,     BSY
	   rjmp    Blink

;-----  WR, OE, LED

       sbi     PORTA,    WR
       sbi     PORTA,    OE
	   sbi     PORTD,    LED   ;   -  .

;--------  ---------
	   
	   ldi     Data,     ChipErase  ;   " "   Data, 
	   rcall   WriteCommand    ;    .
       rcall   Write           ; ,   WR  ""    ( . Write).
	   rcall   Delay10ms       ; -  , ..      
	                           ; BSY   ChipErase,      .1.

;------------- fuse--------------

;-----  fuse-

       ;    fuse-: ,   .

	   ldi     Data,     WriteFuse  ;   " fuse-"   Data,
	   rcall   WriteCommand     ;    .
	   ldi     Data,     LowFuse    ;  fuse-   Data,
	   rcall   WriteData        ;    .
	   cbi     PORTD,    BS1    ;,  fuse-  :
	   cbi     PORTB,    BS2    ;BS1=0, BS2=0 -   fuse-.
	   rcall   Write

;-----  fuse-

       ldi     Data,     WriteFuse   ;     fuse-.
	   rcall   WriteCommand     ; :  WriteFuse   
       ldi     Data,     HghFuse     ;   fuse-,   , 
	   rcall   WriteData        ;,  ,    fuse-  .
	   sbi     PORTD,    BS1    ;BS1=1, BS2=0 -   fuse-.
	   cbi     PORTB,    BS2
	   rcall   Write

;----- - fuse-

       ldi     Data,     WriteFuse
	   rcall   WriteCommand
       ldi     Data,     SecFuse
	   rcall   WriteData
	   cbi     PORTD,    BS1    ;BS1=0, BS2=1 -   fuse-.
	   sbi     PORTB,    BS2
	   rcall   Write

;-----  fuse------

;-----   fuse-
	   
       ldi     Data,     ReadFuse    ; " fuse-"     
	   rcall   WriteCommand     ;,  fuse-      BS1  BS2.

;-----  fuse-

	   cbi     PORTB,    BS1   ;   ,    ,    
       cbi     PORTD,    BS2   ;BS1  BS2,            
       rcall   ReadData        ;    : BS1=0, BS2=1 -   fuse- 
       cpi     Data,     LowFuse     ;(       ,     ).
	   brne    Blink           ;      -    .

;-----  fuse-

       sbi     PORTB,    BS1   ;   fuse- BS1=1, BS2=1 (   
       sbi     PORTD,    BS2   ;    ).
       rcall   ReadData
       cpi     Data,     HghFuse
	   brne    Blink

;----- - fuse-

       cbi     PORTB,    BS1   ;   fuse- BS1=0, BS2=1 (   ,
	   sbi     PORTD,    BS2   ;   ).
       rcall   ReadData
	   cpi     Data,     SecFuse
	   brne    Blink

;------  -  ------

Light:                         ; Exit    ""  .0 -    
       rcall   Exit            ;""  "" (..,    ).
       cbi     PORTD,    LED   ; ""      fuse-  ,
       rjmp    PC+0            ;     ,     .

;-------- -  ---------

Blink:                         ; ""   ,     
       rcall   Exit            ; ;   ,   fuse-    - 
       cbi     PORTD,    LED   ;,    ""  Exit,   
	   rcall   Delay500ms      ;     2 Hz.
	   sbi     PORTD,    LED
	   rcall   Delay500ms      ;    ( ,    ),  
	   rjmp    Blink+1         ; "",      "" (  reset).


;================================

;-------------- --------------

WriteCommand:                  ;.  3     .
                               
	   cbi     PORTD,    XA0   ; ,   ,     . : 
	   cbi     PORTD,    BS1   ;XA0=0, XA1=1, BS1=0. XA0  BS1  ,  XA1(PB7)   :
	   sec                     ;     C,      Data :
	   ror     Data            ;   7=1,    . Data  PORTB        
	   out     PORTB,    Data  ;XA1 "",   PB6-PB0     ,    C
       brcs    PC+3            ; , .    0 . Data    ;  
       cbi     PORTD,    D7    ;   PD6 "" -   ,   C.
	   rjmp    PC+2
       sbi     PORTD,    D7
       rcall   Tact            ; ""  ,       XTAL1.
	   ret

;--------------- --------------

WriteData:
	   sbi     PORTD,    XA0   ;        : XA0=1, XA1=0, 
	   clc                     ;    BS1 (  BS2) ,    (
	   ror     Data            ; )     . ,  XA0 
	   out     PORTB,    Data  ; ,  C    (   XA1  .0);   
       brcs    PC+3            ;BS1  BS2      .  -  , 
       cbi     PORTD,    D7    ;    WriteCommand.
	   rjmp    PC+2
       sbi     PORTD,    D7
       rcall   Tact
	   ret

;---------------- ---------------

ReadData:
       cbi     PORTA,    OE    ;  OE ""       (D0-D7):
       ldi     Temp,     0x80  ; OE=1,     ;   OE=0 -   .  
	   out     DDRB,     Temp  ;""  ;  "", ,   .
	   cbi     DDRD,     6
	   in      Data,     PINB  ; PB0-PB6 (,   PORTB,     ).
	   lsl     Data            ;   ,   ""  7.
       sbis    PIND,     6     ; ,       PD6,     
	   rjmp    PC+3            ;     0  Data.
       sbr     Data,     1
       rjmp    PC+2            ; ,  . Data    fuse-   .
       cbr     Data,     1
	   sbi     PORTA,    OE    ;     ""  ,  "" -  .
       sbi     DDRD,     6     ;,    ,  ,    -     
       ldi     Temp,     0xFF  ;,   ""  ,  ""     ,  
       out     DDRB,     Temp  ;    "";          :)
	   ret

;-------------- --------------
   
Tact:                          ;  XTAL1 "",    ""   "".
       sbi     PORTD,    XT1
	   rcall   Delay1ms        ;       nop-,   ,   1 - .
	   cbi     PORTD,    XT1
	   ret

;----------  ---------

Write:                         ;   ""  ""  WR "".
	   cbi     PORTA,    WR
	   nop                     ;   - -      nop-.
	   nop                     ;     !.. ;)))
       sbi     PORTA,    WR
       sbis    PIND,     BSY   ;  ,     WR  .0,  
	   rjmp    PC-1            ; ,    ""   BSY  .0.
	   ret                     ;     .1,   "" .

;-----  ""  .0------

Exit:
       ldi     Temp,     0x00  ;   ""      ""
	   out     PORTA,    Temp  ;(    )  "":   ,
	   out     PORTB,    Temp  ;   ,  ,    "",
	   out     PORTD,    Temp  ;   -     /?  ..   , ... ;)
	   sbi     PORTD,    RST   ; . 0   RST ""      -  
       ret                     ;   (.  4     ).

;----------  1 ---------

Delay1ms:                      ;  (  ,  -    ) , 
       push    Del1            ;,     "MicroPascal for AVR" -    , 
	   push    Del2            ;      ,   Delay_ms(1), ,   -
       ldi     Del2,     2     ;   -,  - ,  asm-   . 
	   ldi     Del1,     75    ;     ! :(
	   dec     Del1            
	   brne    PC-1            ;P.S. ,   -    ASM,     -  , 
	   dec     Del2            ; ,      AVR -    ,
	   brne    PC-3            ;    (, ,    ) 
	   pop     Del2            ; asm- -     /  -
	   pop     Del1            ; -  ,      ... ;)))
	   ret

;----------  10 ---------

Delay10ms:                     ;     -  -      
       ldi     Del1,     10    ; 10-,    10      Delay1ms?
	   rcall   Delay1ms        ; , ,     (  ,  10), 
	   dec     Del1            ;        ;   flash-   ...
	   brne    PC-2
	   ret

;---------  500 ---------

Delay500ms:                    ;     ,    ? ,   , 
       ldi     Del2,     50    ;   : ! -  50    Delay10ms, ,
	   rcall   Delay10ms       ;  , 10    Delay1ms -  ,    
	   dec     Del2            ;! ;))) " ,   ,   - ,    
	   brne    PC-2            ; ,    ...  .."  :)
	   ret                     ;,    -    !.. ;)))


;==================================
/* 
    1:
    ,      -   
        ,   
""  ""  "  " (.. PORTB-PORTB:  11 -   11,
 12 -   12  ..),       ,  
 - "";        
 ,      .   
      :     ,
  PORTB ""    PORTB ""     -
 ,  ,  ,  ""   , 
   -    (  -   ,  
 !):  ,   "ChipErase" (" "),  -,
   0b10000000;       0b00000001 - ..  7
     0,  6 -    1  ..   : 
"ReadFuse" (" fuse-")  -   0b00000100 - , 
 0b00100000.  ,     ,    
 Data (-  :     ,  (  C), 
    ,   Data   -     8 ),  
      -       
    ... :)  -  -       ...

     ,    fuse-  ATtiny2313.   
    (,  ,   ):
    : 0b01100100;
    : 0b11011111;
   . :0bxxxxxxx1;
: 0-, 1- , x-.    
:   AVR fuse-  ,    
.0 (..   )!!!

   Fuse-   ATtiny2313   :
 :
#7 - CKDIV8 -    (  )  8;
#6 - CKOUT -      CKOUT;
#5 - SUT1 -     ;
#4 - SUT0 -     ;
#3 - CKSEL3 -        ;
#2 - CKSEL2 -        ;
#1 - CKSEL1 -        ;
#0 - CKSEL0 -        .

 :
#7 - DWEN -      debugWire;
#6 - EESAVE -    EEPROM   ;
#5 - SPIEN -    SPI;
#4 - WDTON -      ;
#3 - BODLEVEL2 -      ;
#2 - BODLEVEL1 -      ;
#1 - BODLEVEL0 -      ;
#0 - RSTDISBL -      reset -  
  .0 ()        SPI.

 :
#7-1 -   (  Atmel   );
#0 - SELFPRGEN -   .


 2:
    -   "".  ,   
,  .1   BSY.  "" ,
      ,   "" -
    PIND5 ""  .0,    
;     .  , 
  ,     BSY (  ?) -
    ""   ;
  BSY   Write    
(rcall Delay10ms) -  , ,    ... 


 3:
    ,  ,     ,
   ""   ,     
      ,     PORTB
""  /,  : PB0-PB6 ""
   D6-D0 "", PD6 -   D7,  PB7 ""
    XA1/BS2 "".   
  ,   -  /,
   Data,   D0-D7 "",  
    XA1.


 4:
      ,   " ", 
    ,     
RST   (..,      ).
  ,       (..,
    RST  +12 ), ""   
 +5   150  (    
 );      78L05 (
   100 ),    ""   + .
 ,       ( ), 
  78L05  -     ,
  >200 ,       ;  
  ""        -
      ~1 ,    78L05 
 (~10 ).    ,    
,     .    ,
     78L05,        
" " 7805.*/
